## Zope PostgreSQL DataBase Adapter based on PoPy Python Postgres Driver 
## --------------------------------------------------------------------- 

## Copyright (c) 2000 - Thierry MICHEL 
## Copyright (c) 2000 - MixadLive srl Torino, Italy 
## http://www.mixadlive.com 

## This library is free software, you can redistribute it and/or 
## modify it under the terms of the GNU Lesser General Public Licence as  
## published by the Free Software Foundation. 

## This program is distributed in the hope that it will be useful, 
## but WITHOUT ANY WARRANTY; without even the implied warranty of 
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
## GNU Lesser General Public License for more details 

## You should have received a copy of the GNU Lesser General Public License 
## along with this program; if not, write to the Free Software 
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 

## MixadLive, Srl., hereby disclaims all copyright 
## interest in the Zope Database Adapter `ZPoPyDA' written  
## by Thierry MICHEL 

## -- Thierry - Developer 
## For bugs & comments: thierry@developers.mixadlive.com 

__version__ = '0.5.1'

try:
    __compatibility__ = ('1.2',)
    try:
        import PoPy
    except ImportError:
        raise "The PoPy module is not installed"
    if not PoPy.__version__ in __compatibility__:
        raise "update your version of PoPy"
except AttributeError:
    raise "update your version of PoPy"
    
import sys
from Shared.DC.ZRDB.TM import TM
import string, sys
from string import strip, split, find,replace
from types import *


DB_Error = PoPy.Error

class DB(TM):
    """DB class from PoPy driver"""

    def __init__(self,po_conx):
        self._conx = PoPy.connect(po_conx)
        self._conxString = po_conx
        self._cursor = self._conx.cursor

    def autoCommit(self,autocommit):
        self._conx.autoCommit(autocommit)
        
    def query(self,ps_queryString, pl_maxRows=9999999):
        f = open("/tmp/zop","a")
        f.write("QUERY: %s\n" % self._conx.auto_commit_mode)
        f.close()
        o_desc = None
        o_result = (); o_items = []
        self._register()
        o_cur = self._cursor()
        ps_queryString = replace(ps_queryString,"\n"," ")
        try:

            for q in filter(None, map(strip,split(ps_queryString, '\0'))):
                o_ret = o_cur.execute(q)
                if o_ret is None:
                    if o_desc is not None:
                        if o_cur.description != o_desc:
                            raise 'Query Error', (
                                'Multiple select schema are not allowed'
                                )
                        if type(o_result) is not ListType: o_result=list(o_result)
                        if self._conx.auto_commit_mode == 'OFF':
                            if pl_maxRows:
                                try:
                                    for r in o_cur.fetchmany(pl_maxRows-len(o_result)):
                                        o_result.append(r)
                                except:
                                    pass
                        else:
                            try:
                                o_result = o_cur.fetchall()
                            except:
                                pass
                    else:
                        if self._conx.auto_commit_mode == 'OFF':
                            if pl_maxRows:
                                try:
                                    if pl_maxRows==1: o_result=(o_cur.fetchone(),)
                                    else: o_result=o_cur.fetchmany(pl_maxRows)
                                except:
                                    pass
                        else:
                            try:
                                o_result = o_cur.fetchall()
                            except:
                                pass
                        o_desc = o_cur.description

            o_cur.close()
        except (DB_Error), s_mesg:
            o_cur.close()
            raise sys.exc_type, sys.exc_value, sys.exc_traceback
        
        if o_desc is None: return (),()
        
        o_col = map(None,o_desc[0],o_desc[1],o_desc[2],o_desc[3])
        
        for n,t,w,z in o_col:
            o_items.append({'name':n,'type':t,'width':w,'null':z})

        return o_items,o_result
    
    def _finish (self):
        try:
            if self._conx.auto_commit_mode == 'OFF':
                self._conx.commit()
        except (DB_Error), s_mesg:
            raise sys.exc_type, sys.exc_value, sys.exc_traceback
        

    def _abort (self):
        try:
            self._conx.rollback()
        except (DB_Error),s_mesg:
            raise sys.exc_type, sys.exc_value, sys.exc_traceback
        
    def _begin (self):
        pass


